#!/usr/bin/perl
#
# IPCop CGIs
#
# This code is distributed under the terms of the GPL
#
# Copyright (c) 2006-2008 by Stephan Feddersen 
#
# $Id: wiofunc.pl, ver. 5.8 2008/12/05 s.feddersen Exp $
#

package wiofunc;

use strict;
use GD;

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";

my $addonupdate = "${General::swroot}/wio/.update";
my $redactive = "${General::swroot}/red/active";
my $imagedir = "/home/httpd/html/graphs/wio";

my ($dest, $ipadr, $host, $enable, $remark, $dyndns, $mailon, $mailoff, $ping, $on, $count);

my @newline;
my @oldline;
my @file;

my $owner = getpwnam "nobody";
my $group = getgrnam "nobody";

############################################################################################################################

sub rewrite {
	if ( $count == 8 )
	{
		foreach (@file) {
			chomp;
			($ipadr,$host,$enable,$remark,$dyndns,$mailoff,$ping,$on) = split( /\,/, $_ );
			push (@newline, "$ipadr,$host,$enable,$remark,$dyndns,$mailon,$mailoff,$ping,$on\n");
		}
	}
	elsif ( $count == 7 )
	{
		foreach (@file) {
			chomp;
			($ipadr,$host,$enable,$remark,$dyndns,$mailoff,$ping) = split( /\,/, $_ );
			push (@newline, "$ipadr,$host,$enable,$remark,$dyndns,$mailon,$mailoff,$ping,$on\n");
		}
	}

	open(FILE, "> $dest");
	print FILE @newline;
	close(FILE);
	
	chmod ( 0644, $dest ); 
	chown ( $owner, $group, $dest );
}

sub count {
	foreach (@file) {
		chomp;
		@oldline = split( /\,/, $_ );
		$count = @oldline;
	}

	if ( $count >= 9 ) { return 0; }
	elsif ( $count == 8 ) { &rewrite; }
	elsif ( $count == 7 ) { &rewrite; }
	else { return -1; }
}

sub check{
	$dest = $_[0];
	if ( -e $dest ) {
		open (FILE, "< $dest") or die "Can`t open $dest file.\n";
		@file = <FILE>;
		close FILE;
	}
	&count;
}

############################################################################################################################

sub wanpng
{
	my ($bgcolor, $mesg, $wanpng, $f, $h, $w, $xpos, $ypos, $black);
	my $height = 15;

	$f = GD::Font->Small;
	$f = gdMediumBoldFont;
	$h = $height;
	$h = $f->height+2 if( $h <( $f->height+2));
	$w = $f->width * 5 + 78;

	$wanpng = new GD::Image($w,$h);
	$black = $wanpng->colorAllocate(204,204,204);

	if ( -e $redactive )
	{
		$bgcolor = $wanpng->colorAllocate(51,153,51);
		$mesg = "$Lang::tr{'wio_wan_up'}";
	}
	else
	{
		$bgcolor = $wanpng->colorAllocate(153,51,51);
		$mesg = "$Lang::tr{'wio_wan_down'}";
	}

	$xpos = 5;
	$ypos = ($height - $f->height)/2;
	$wanpng->fill(0,0,$bgcolor);
	$wanpng->string($f,$xpos,$ypos,$mesg,$black);

	my $newwanpng = $wanpng->png();

	open(PIC,"> $imagedir/wiowan.png") or die 'Unable to create image';
	binmode PIC;
	print PIC $newwanpng;
	close (PIC);
}

############################################################################################################################

sub vpnstatuspng
{
	my ($bgcolor, $mesg, $vpnclosedpng, $f, $h, $w, $xpos, $ypos, $black);
	my $height = 15;

	$f = GD::Font->Small;
	$f = gdMediumBoldFont;
	$h = $height;
	$h = $f->height+2 if( $h <( $f->height+2));
	$w = $f->width * 5 + 78;

	$vpnclosedpng = new GD::Image($w,$h);
	$black = $vpnclosedpng->colorAllocate(204,204,204);
	$bgcolor = $vpnclosedpng->colorAllocate(153,51,51);
	$mesg = "$Lang::tr{'wio_vpn_down'}";

	$xpos = 5;
	$ypos = ($height - $f->height)/2;
	$vpnclosedpng->fill(0,0,$bgcolor);
	$vpnclosedpng->string($f,$xpos,$ypos,$mesg,$black);

	my $newvpnclosedpng = $vpnclosedpng->png();

	open(PIC,"> $imagedir/wiovpnclosed.png") or die 'Unable to create image';
	binmode PIC;
	print PIC $newvpnclosedpng;
	close (PIC);
}

############################################################################################################################

sub vpnoff
{
	my ($bgcolor, $mesg, $vpnoffpng, $f, $h, $w, $xpos, $ypos, $black);
	my $height = 15;

	$f = GD::Font->Small;
	$f = gdMediumBoldFont;
	$h = $height;
	$h = $f->height+2 if( $h <( $f->height+2));
	$w = $f->width * 5 + 78;

	$vpnoffpng = new GD::Image($w,$h);
	$black = $vpnoffpng->colorAllocate(204,204,204);
	$bgcolor = $vpnoffpng->colorAllocate(51,51,153);
	$mesg = "$Lang::tr{'wio_vpn_down'}";

	$xpos = 5;
	$ypos = ($height - $f->height)/2;
	$vpnoffpng->fill(0,0,$bgcolor);
	$vpnoffpng->string($f,$xpos,$ypos,$mesg,$black);

	my $newvpnoffpng = $vpnoffpng->png();

	open(PIC,"> $imagedir/wiovpnoff.png") or die 'Unable to create image';
	binmode PIC;
	print PIC $newvpnoffpng;
	close (PIC);
}

############################################################################################################################

sub vpnopen
{
	my ($bgcolor, $mesg, $vpnopenpng, $f, $h, $w, $xpos, $ypos, $black);
	my $height = 15;

	$f = GD::Font->Small;
	$f = gdMediumBoldFont;
	$h = $height;
	$h = $f->height+2 if( $h <( $f->height+2));
	$w = $f->width * 5 + 78;

	$vpnopenpng = new GD::Image($w,$h);
	$black = $vpnopenpng->colorAllocate(204,204,204);
	$bgcolor = $vpnopenpng->colorAllocate(51,153,51);
	$mesg = "$Lang::tr{'wio_vpn_up'}";

	$xpos = 5;
	$ypos = ($height - $f->height)/2;
	$vpnopenpng->fill(0,0,$bgcolor);
	$vpnopenpng->string($f,$xpos,$ypos,$mesg,$black);

	my $newvpnopenpng = $vpnopenpng->png();

	open(PIC,"> $imagedir/wiovpnopen.png") or die 'Unable to create image';
	binmode PIC;
	print PIC $newvpnopenpng;
	close (PIC);
}

############################################################################################################################

sub ovpnstatuspng
{
	if ( -e "$imagedir/wioovpnclosed.png" )
	{
		unlink "$imagedir/wioovpnclosed.png";
	}

	my ($bgcolor, $mesg, $ovpnclosedpng, $f, $h, $w, $xpos, $ypos, $black);
	my $height = 15;

	$f = GD::Font->Small;
	$f = gdMediumBoldFont;
	$h = $height;
	$h = $f->height+2 if( $h <( $f->height+2));
	$w = $f->width * 5 + 78;

	$ovpnclosedpng = new GD::Image($w,$h);
	$black = $ovpnclosedpng->colorAllocate(204,204,204);
	$bgcolor = $ovpnclosedpng->colorAllocate(153,51,51);
	$mesg = "$Lang::tr{'wio_vpn_down'}";

	$xpos = 5;
	$ypos = ($height - $f->height)/2;
	$ovpnclosedpng->fill(0,0,$bgcolor);
	$ovpnclosedpng->string($f,$xpos,$ypos,$mesg,$black);

	my $newovpnclosedpng = $ovpnclosedpng->png();

	open(PIC,"> $imagedir/wioovpnclosed.png") or die 'Unable to create image';
	binmode PIC;
	print PIC $newovpnclosedpng;
	close (PIC);
}

############################################################################################################################

sub ovpnoff
{
	my ($bgcolor, $mesg, $ovpnoffpng, $f, $h, $w, $xpos, $ypos, $black);
	my $height = 15;

	$f = GD::Font->Small;
	$f = gdMediumBoldFont;
	$h = $height;
	$h = $f->height+2 if( $h <( $f->height+2));
	$w = $f->width * 5 + 78;

	$ovpnoffpng = new GD::Image($w,$h);
	$black = $ovpnoffpng->colorAllocate(204,204,204);
	$bgcolor = $ovpnoffpng->colorAllocate(51,51,153);
	$mesg = "$Lang::tr{'wio_vpn_down'}";

	$xpos = 5;
	$ypos = ($height - $f->height)/2;
	$ovpnoffpng->fill(0,0,$bgcolor);
	$ovpnoffpng->string($f,$xpos,$ypos,$mesg,$black);

	my $newovpnoffpng = $ovpnoffpng->png();

	open(PIC,"> $imagedir/wioovpnoff.png") or die 'Unable to create image';
	binmode PIC;
	print PIC $newovpnoffpng;
	close (PIC);
}

############################################################################################################################

sub ovpnopen
{
	my ($bgcolor, $mesg, $ovpnopenpng, $f, $h, $w, $xpos, $ypos, $black);
	my $height = 15;

	$f = GD::Font->Small;
	$f = gdMediumBoldFont;
	$h = $height;
	$h = $f->height+2 if( $h <( $f->height+2));
	$w = $f->width * 5 + 78;

	$ovpnopenpng = new GD::Image($w,$h);
	$black = $ovpnopenpng->colorAllocate(204,204,204);
	$bgcolor = $ovpnopenpng->colorAllocate(51,153,51);
	$mesg = "$Lang::tr{'wio_vpn_up'}";

	$xpos = 5;
	$ypos = ($height - $f->height)/2;
	$ovpnopenpng->fill(0,0,$bgcolor);
	$ovpnopenpng->string($f,$xpos,$ypos,$mesg,$black);

	my $newovpnopenpng = $ovpnopenpng->png();

	open(PIC,"> $imagedir/wioovpnopen.png") or die 'Unable to create image';
	binmode PIC;
	print PIC $newovpnopenpng;
	close (PIC);
}

############################################################################################################################

sub noimagepng
{
	my ($bgcolor, $mesg, $noimagepng, $f, $h, $w, $xpos, $ypos, $black);
	my $height = 15;

	$f = GD::Font->Small;
	$f = gdMediumBoldFont;
	$h = $height;
	$h = $f->height+2 if( $h <( $f->height+2));
	$w = $f->width * 5 + 78;

	$noimagepng = new GD::Image($w,$h);
	$black = $noimagepng->colorAllocate(204,204,204);
	$bgcolor = $noimagepng->colorAllocate(129,129,129);
	$mesg = "$Lang::tr{'wio_no_image'}";

	$xpos = 5;
	$ypos = ($height - $f->height)/2;
	$noimagepng->fill(0,0,$bgcolor);
	$noimagepng->string($f,$xpos,$ypos,$mesg,$black);

	my $newnoimagepng = $noimagepng->png();

	open(PIC,"> $imagedir/wionoimage.png") or die 'Unable to create image';
	binmode PIC;
	print PIC $newnoimagepng;
	close (PIC);
}

############################################################################################################################

sub updatecheck
{
	my $version = shift;

	if ( (! -e $redactive) || (-e $addonupdate) && (int(-M $addonupdate) < 5) )
	{
		return;
	}

	my $update = LWP::UserAgent->new;
	$update->timeout(120);
	my $content = $update->get("http://www.h-loit.de/update/wioversion");

	if ( $content->is_success )
	{
		$content->content =~ /(\d+).(\d+)/;
		my $ver1 = $1;
		my $ver2 = $2;

		$version =~ /(\d+).(\d+)/;

		if ( ($ver1 > $1) || (($ver1 == $1) && ($ver2 > $2)) )
		{
			return "$content";
		}
		else
		{
			system('/bin/touch', "$addonupdate");
		}
	}	
}

############################################################################################################################

sub getip
{
	my $host = shift;
	
	if ( -e $redactive )
	{
		my @fetchip = ();

		@fetchip = gethostbyname($host);

		if ($fetchip[0] ne '')
		{
			@fetchip = map ( &Socket::inet_ntoa($_), @fetchip[4..$#fetchip]);

			return "$fetchip[0]";
		}
	}
	else
	{
		return;
	}
}
